function find_torso(mask)
im_target = mask; 
im_target = im2double(im_target);
imx = ones(54*2, 30*2);
psum = 54 * 30 * 4;

cost = [];
for n = 1 : 7       
         n

         thita = (n-4) * 15;
         im_temp = imrotate(imx, thita);
         
         red_ch = im_target;

         r_c = conv2(red_ch, im_temp, 'same');

         total_dif = r_c;
         ord = 5;
         map_smooth = ordfilt2(total_dif, 25, ones(ord, ord));
         thresh = 0.0;
         cim = (total_dif==map_smooth)&(map_smooth>100);
         [rr,cc] = find(cim);
         for m = 1 : length(rr)
             cost = [cost; map_smooth(rr(m), cc(m)), n, rr(m), cc(m)];
         end

end

[cst, id] = sort(cost(:,1), 'descend');
imshow(im_target);
hold on;

fd = fopen('match.txt', 'wt');
fdr = fopen('matchr.txt', 'wt');
dt = [];
dtr = [];
cn = 0;
torsoN = 20;
for n = 1 : min(length(id), torsoN)
            u = cost(id(n),4);
            v = cost(id(n),3);
            thita = (cost(id(n),2) - 4) * 15;
            thita = thita * pi / 180;
            [h,w] = size(imx);
            x1  = u - 30;
            y1  = v - 54;
            x2  = u + 30;
            y2  = v + 54;
            rmat = [cos(thita), sin(thita), u; -sin(thita), cos(thita), v];
            p = [x1-u, x2-u, x2-u, x1-u; y1-v, y1-v, y2-v, y2-v; 1, 1, 1, 1];
            q = rmat * p;

            t = [0, 0; -40, 35; 1, 1];
            w = round(rmat * t);

            if w(1,1) > 0 & w(2,1) > 0 & w(1,2) > 0 & w(2,2) > 0
               plot(w(1,:), w(2, :), '-*');
               plot(q(1,:), q(2, :), '-*');
               dtr = [dtr; w(1,1), w(2,1), w(1,2), w(2,2), thita, 1 - cst(n)/psum];
               dt = [dt;  w(1,2), w(2,2), w(1,1), w(2,1), thita, 1 - cst(n)/psum];
               cn = cn + 1;
            end
end

fprintf(fd, '%d\n', cn);
fprintf(fdr, '%d\n', cn);
for n = 1 : cn
    fprintf(fdr, '%d %d %d %d %f %f\n', dtr(n,1), dtr(n,2), dtr(n,3), dtr(n,4), dtr(n,5), dtr(n,6));
    fprintf(fd, '%d %d %d %d %f %f\n', dt(n,1), dt(n,2), dt(n,3), dt(n,4), dt(n,5), dt(n,6));
end

fclose(fd);
fclose(fdr);

system('cp match.txt objects_info_h1_2.txt');
system('cp match.txt objects_info_h2_2.txt');
system('cp matchr.txt objects_info_h3_2.txt');
system('cp matchr.txt objects_info_h4_2.txt');

system('cp match.txt part1.txt');

pause(0.2);
hold off;
