%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%          Maxcover for pose estimation           %
%            Hao Jiang, Boston College            %
%                 December  2012                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    imc = imread('test.png'); 
    h = rgb2hsv(imc);
    msk = h(:,:,2) > 0.12;
    msk = im2double(msk);
    mask = imresize(msk, [50, 50]);
    mask = mask > 0.1;
    mask = im2double(mask);
    save mask.txt mask -ascii
    imwrite(msk, 'mask.bmp');

    find_head(msk);
    find_torso(msk);
    part_match_costs;
    system('./makelp2_alt > big.lp');
    system('~/glpk/bin/glpsol --cpxlp big.lp -o out.txt');
    system('sh parse.sh');
    %show_results;
    reduce;
    system('./makelp2_alti > small.lp');
    system('~/glpk/bin/glpsol --cpxlp small.lp -o out.txt');
    system('sh parse.sh');
    show_result_box;
    
